/***************************************************************************
 *   Copyright (C) 2001 AVM GmbH. All rights reserved.                     *
 *   Copyright (C) 1998-2000 Markus Dahlweid                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _KIsdnInfoLine_H_
#define _KIsdnInfoLine_H_

#include <qwidget.h>
#include <qlabel.h>
#include <qdatetm.h>

#include "kimoninfostatus.h"

class KIsdnInfoLine : public QWidget
{
    Q_OBJECT
public:
    KIsdnInfoLine (QWidget* parent = 0, bool panel = true, const char* name = 0);
    ~KIsdnInfoLine ();

public slots:
    void set_controller (int);
    void set_controller (const char*);
    void set_channel (int);
    void set_channel (const char*);
    void set_online (int);
    void set_time (const char*);
    void reset_time ();
    void recalc_time ();
    
protected:
		QLabel*								m_pLabelController;
		QLabel*								m_pLabelChannel;
		QLabel*								m_pLabelStatus;
		QLabel*								m_pLabelTime;
    QDateTime							_upsince;
    int 									dur, sec, min, hou;
    char									timestr[12];
    KIsdnInfoLineStatus*	m_pLed;
    int										_onl;
    bool									_panel;
};

#endif
